import type { PropType, ExtractPropTypes } from 'vue';
import type Banner from './banner.vue';
export declare const bannerProps: {
    modelValue: {
        type: BooleanConstructor;
        required: boolean;
    };
    title: {
        type: StringConstructor;
        default: string;
    };
    description: {
        type: StringConstructor;
        default: string;
    };
    type: {
        type: PropType<"success" | "warning" | "error" | "info">;
        default: string;
    };
    closable: {
        type: BooleanConstructor;
        default: boolean;
    };
    closeText: {
        type: StringConstructor;
        default: string;
    };
    showIcon: BooleanConstructor;
    effect: {
        type: PropType<"light" | "dark">;
        default: string;
    };
    placement: {
        type: PropType<"top" | "bottom">;
        default: string;
    };
    animationName: {
        type: StringConstructor;
        default: string;
    };
    to: {
        type: StringConstructor;
        default: string;
    };
    zIndex: NumberConstructor;
    height: StringConstructor;
    position: PropType<"fixed" | "absolute">;
    timeout: NumberConstructor;
};
export type BannerProps = ExtractPropTypes<typeof bannerProps>;
export declare const bannerEmits: {
    close: () => boolean;
    'update:modelValue': (visible: boolean) => boolean;
};
export type BannerEmits = typeof bannerEmits;
export type BannerInstance = InstanceType<typeof Banner>;
