import type { VNode } from 'vue';
import type { ModelessDialogProps, ModelessInsance } from './modeless-dialog';
export type ModelessDialogOptions = Partial<ModelessDialogProps & {
    header?: VNode;
    body?: VNode;
    footer?: VNode;
    onResize?: (dlg: HTMLDivElement) => void;
    onOpen?: () => void;
    onOpened?: () => void;
    onClose?: () => void;
    onClosed?: () => void;
    onDestroy?: () => void;
    onCollapse?: (value: boolean) => void;
    onMaximize?: (value: boolean) => void;
}>;
declare function show(options?: ModelessDialogOptions): ModelessInsance;
declare function closeAll(): void;
declare function showAll(): void;
declare function hideAll(): void;
declare function collapseAll(): void;
declare function expandAll(): void;
declare function get(id: string): ModelessInsance;
declare function has(id: string): boolean;
declare function addEventListener(listener: Record<string, (id: string) => void>): () => void;
declare function triggerEvent(name: string, id: string): void;
declare const ModelessDialogManager: {
    get: typeof get;
    has: typeof has;
    show: typeof show;
    closeAll: typeof closeAll;
    showAll: typeof showAll;
    hideAll: typeof hideAll;
    collapseAll: typeof collapseAll;
    expandAll: typeof expandAll;
    addEventListener: typeof addEventListener;
    triggerEvent: typeof triggerEvent;
};
export { ModelessDialogManager };
