import { defineComponent as B, toRefs as T, getCurrentInstance as j, inject as E, h as n, withDirectives as q, vShow as D } from "vue";
import { ElIcon as O, ElPopover as $ } from "element-plus";
import { ArrowRightBold as F } from "@element-plus/icons-vue";
import { EppSpinner as L } from "../../../spinner/index.mjs";
import M from "./default-cell-content.vue.mjs";
import { simpleTableContextKey as P } from "../simple-table.mjs";
const J = B({
  props: {
    row: {
      type: Object,
      required: !0
    },
    column: {
      type: Object,
      required: !0
    },
    rowIndex: {
      type: Number,
      required: !0
    },
    columnIndex: {
      type: Number,
      required: !0
    },
    width: String,
    minWidth: String,
    maxWidth: String,
    expanded: Boolean,
    showTooltip: Boolean,
    hasChildren: Boolean,
    hasTreeData: Boolean,
    isLoading: Boolean,
    treeExpanded: Boolean,
    firstColumnIndex: Number,
    cellClassName: {
      type: [String, Function],
      default: ""
    },
    cellStyle: {
      type: [Object, Function],
      default: () => ({})
    },
    span: Object
  },
  emits: ["mouseover", "mouseleave", "expand", "tree-expand", "cell-click"],
  setup(e, { emit: o, slots: c }) {
    const { row: i, column: l, rowIndex: r, columnIndex: s } = T(e), I = typeof e.cellClassName == "string" ? e.cellClassName : e.cellClassName({
      row: i.value,
      column: l.value,
      rowIndex: r.value,
      columnIndex: s.value
    }), y = typeof e.cellStyle == "function" ? e.cellStyle({
      row: i.value,
      column: l.value,
      rowIndex: r.value,
      columnIndex: s.value
    }) : e.cellStyle, { $parent: v } = j().proxy, { isShowCol: g, getColFixed: d, hoverColIndex: p } = E(P);
    return () => {
      var x, f, h, w, C;
      const S = e.width ?? (l.value.width ? l.value.width : !1), N = e.minWidth ?? (l.value.minWidth ? l.value.minWidth : !1), W = e.maxWidth ?? (l.value.maxWidth ? l.value.maxWidth : !1), m = l.value.align ? l.value.align : !1;
      let t = null;
      e.columnIndex === e.firstColumnIndex && (e.isLoading ? t = n("div", { class: "expand-icon" }, [n(L)]) : e.hasChildren ? t = n(
        "div",
        {
          class: "expand-icon cursor-pointer",
          onClick: () => o("tree-expand")
        },
        [n(O, null, { default: () => [n(F)] })]
      ) : v.$props.level ? t = n("div", {
        class: "placeholder-icon"
      }) : !v.$props.level && e.hasTreeData && (t = n("div", {
        class: "placeholder-icon"
      })));
      let u = null;
      if (l.value.slotName)
        u = n(
          "div",
          {
            class: "cell",
            style: [
              {
                "justify-content": m
              }
            ],
            onClick: (a) => o("cell-click", a)
          },
          [t, (x = c.default) == null ? void 0 : x.call(c)]
        );
      else {
        const a = n(
          M,
          {
            row: i.value,
            column: l.value,
            onCellClick: (k) => o("cell-click", k),
            onExpand: () => o("expand"),
            rowIndex: r.value,
            columnIndex: s.value
          },
          t ? {
            "expand-icon": () => n(t)
          } : {}
        );
        e.showTooltip ? u = n(
          $,
          {
            content: i.value[l.value.prop],
            placement: "top",
            effect: "dark",
            tooltip: !0,
            ...l.value.tooltipProps
          },
          {
            reference: () => a
          }
        ) : u = a;
      }
      const b = q(
        n(
          "td",
          {
            rowspan: (f = e.span) == null ? void 0 : f.rowspan,
            colspan: (h = e.span) == null ? void 0 : h.colspan,
            class: [
              m ? `align-${m}` : "",
              {
                "show-tooltip": l.value.showTooltip,
                ["fixed-" + d(l.value).position]: !!l.value.fixed,
                "show-shadow": d(l.value).hasShadow,
                expanded: e.expanded,
                "first-column-index": e.columnIndex === e.firstColumnIndex,
                "tree-expanded": e.columnIndex === e.firstColumnIndex && e.treeExpanded
              },
              I
            ],
            style: [
              {
                width: S,
                "min-width": N,
                "max-width": W
              },
              l.value.fixed && d(l.value, e.columnIndex).distance ? "--table-fixed-distance:" + d(l.value, e.columnIndex).distance : "",
              y
            ],
            onMouseover: (a) => {
              p.value = e.columnIndex, o("mouseover", a);
            },
            onMouseleave: (a) => o("mouseleave", a)
          },
          [u]
        ),
        [[D, g(l.value)]]
      );
      return !((w = e.span) != null && w.rowspan) || !((C = e.span) != null && C.rowspan) ? null : b;
    };
  }
});
export {
  J as default
};
