import { defineComponent as oe, ref as g, toRefs as ae, computed as m, watch as ne, onMounted as se, provide as re } from "vue";
import { useLocale as ie } from "element-plus";
import { cloneDeep as y, findLast as ce } from "lodash-unified";
import de from "./sortable.vue.mjs";
import fe from "./filter.vue.mjs";
import ue from "./body/row.vue.mjs";
import { simpleTableProps as he, simpleTableContextKey as me } from "./simple-table.mjs";
import { convertCols as we } from "./utils.mjs";
import { useExpand as ge } from "./composables/use-expand.mjs";
import { useTooltip as xe } from "./composables/use-tooltip.mjs";
import { useTree as Ce } from "./composables/use-tree.mjs";
import { useResizer as ye } from "./composables/use-resizer.mjs";
import { useScroll as pe } from "./composables/use-scroll.mjs";
const Ke = oe({
  name: "EppSimpleTable",
  components: { BodyRow: ue, SortableIcon: de, FilterIcon: fe },
  props: he,
  emits: ["row-click", "cell-click", "sort-change", "expand", "tree-expand", "current-change"],
  setup(l, { emit: x }) {
    const { t: I } = ie(), M = "epp-simple-table", w = g(), c = g(), p = g(""), v = g(""), {
      rowClassName: k,
      rowStyle: A,
      cellClassName: K,
      cellStyle: L,
      firstColumnIndex: W,
      expandRowKeys: S,
      defaultExpandAll: R,
      cols: d
    } = ae(l), i = m(() => we(y(d.value))), $ = m(() => i.value.realCols.filter((e) => e.slotName).map((e) => e.slotName)), N = m(
      () => i.value.realCols.filter((e) => {
        var t;
        return (t = e.expand) == null ? void 0 : t.slotName;
      }).map((e) => {
        var t;
        return (t = e.expand) == null ? void 0 : t.slotName;
      })
    ), f = m(() => l.data ?? []), j = m(
      () => f.value.some(
        (e) => e[l.treeProps.hasChildren] || Array.isArray(e[l.treeProps.children]) && e[l.treeProps.children].length
      )
    ), { toggleExpandRow: D, expandedKeyExisted: H, toggleExpand: F } = ge({
      expandRowKeys: S,
      getRowKey: C,
      defaultExpandAll: R
    }), { isShowTooltipMap: z, clearTooltip: O, tdMouseover: V, tdMouseleave: _ } = xe(i), { tableTreeMap: q, hasChildren: B, toggleExpandTree: b, walkTreeNode: T } = Ce({
      load: l.load,
      treeProps: l.treeProps,
      getRowKey: C,
      expandRowKeys: S,
      defaultExpandAll: R
    });
    ye(l.resize, d, w);
    const { scrollClass: G } = pe(l.scrollContainer, i, w);
    function C(e) {
      const t = l.rowKey;
      if (!e) throw new Error("Row is required when get row identity");
      if (typeof t == "string") {
        if (t.indexOf(".") < 0)
          return e[t] + "";
        const n = t.split(".");
        let a = e;
        for (let o = 0; o < n.length; o++)
          a = a[n[o]];
        return a + "";
      } else if (typeof t == "function")
        return t.call(null, e);
      return e.id;
    }
    const E = (e) => !("$show$" in e) || !!e.$show$, J = (e, t) => {
      d.value[e].$show$ = t ?? !(!("$show$" in d.value[e]) || d.value[e].$show$);
    }, P = (e, t) => {
      var o, s;
      const n = (r) => {
        var u;
        return typeof r.fixed == "string" ? r.fixed : (u = r.fixed) == null ? void 0 : u.position;
      }, a = {
        hasShadow: !1,
        position: n(e),
        distance: typeof e.fixed == "string" ? 0 : ((o = e.fixed) == null ? void 0 : o.distance) === "auto" ? `var(--fixed-${n(e)}-column-${t})` : (s = e.fixed) == null ? void 0 : s.distance
      };
      return a.position === "left" ? a.hasShadow = ce(i.value.realCols, (r) => n(r) === "left") === e : a.position === "right" && (a.hasShadow = i.value.realCols.find((r) => n(r) === "right") === e), a;
    }, Q = ({ row: e, rowIndex: t }) => typeof l.headerRowClassName == "string" ? l.headerRowClassName : l.headerRowClassName({ row: e, rowIndex: t }), U = ({ row: e, rowIndex: t }) => typeof l.headerRowStyle == "function" ? l.headerRowStyle({ row: e, rowIndex: t }) : l.headerRowStyle, X = ({ row: e, column: t, rowIndex: n, columnIndex: a }) => typeof l.headerCellClassName == "string" ? l.headerCellClassName : l.headerCellClassName({ row: e, column: t, rowIndex: n, columnIndex: a }), Y = ({ row: e, column: t, rowIndex: n, columnIndex: a }) => typeof l.headerCellStyle == "function" ? l.headerCellStyle({ row: e, column: t, rowIndex: n, columnIndex: a }) : l.headerCellStyle, Z = (...e) => {
      const [t, n, a] = e;
      l.highlightCurrentRow && (x("current-change", t, y(c.value)), c.value = c.value === t ? null : t), x("row-click", t, n, a);
    }, ee = (e) => {
      l.highlightCurrentRow && (x("current-change", e, y(c.value)), c.value = e ?? null);
    }, te = ({ row: e, column: t, rowIndex: n, columnIndex: a }) => {
      const o = { rowspan: 1, colspan: 1 };
      if (l.spanMethod) {
        const s = l.spanMethod({ row: e, column: t, rowIndex: n, columnIndex: a });
        Array.isArray(s) ? (o.rowspan = s[0], o.colspan = s[1]) : typeof s == "object" && Object.assign(o, s);
      }
      return o;
    }, le = () => {
      const e = w.value.rows, t = [];
      if (!e.length) return;
      const n = e[0].cells.length;
      for (let o = 0; o < n; o++)
        t[o] = e[0].cells[o].offsetWidth;
      const a = [];
      for (let o = 0, s = 0, r = 0; o < n; o++) {
        const u = n - o - 1;
        let h = e[0].cells[o];
        h.classList.contains("fixed-left") && (h.style.getPropertyValue("--table-fixed-distance").startsWith("var(--fixed") && a.push(`--fixed-left-column-${o}:${s}px`), s += t[o]), h = e[0].cells[u], h.classList.contains("fixed-right") && (h.style.getPropertyValue("--table-fixed-distance").startsWith("var(--fixed") && a.push(`--fixed-right-column-${n - o - 1}:${r}px`), r += t[u]);
      }
      p.value = a.join(";");
    };
    return ne(f, () => {
      T(f.value);
    }), se(() => {
      T(f.value), le();
    }), re(me, {
      rowClassName: k,
      rowStyle: A,
      cellClassName: K,
      cellStyle: L,
      firstColumnIndex: W,
      load: l.load,
      getSpan: te,
      currentSelectedRow: c,
      slotNames: $,
      expandSlotNames: N,
      realColsInfo: i,
      getRowKey: C,
      toggleExpandRow: D,
      expandedKeyExisted: H,
      isShowTooltipMap: z,
      tdMouseover: V,
      tdMouseleave: _,
      tableTreeMap: q,
      hasChildren: B,
      hasTreeData: j,
      toggleExpandTree: b,
      isShowCol: E,
      getColFixed: P,
      hoverColIndex: v
    }), {
      t: I,
      namespace: M,
      tableRef: w,
      fixedColumnsStyle: p,
      isShowCol: E,
      getColFixed: P,
      realColsInfo: i,
      slotNames: $,
      expandSlotNames: N,
      scrollClass: G,
      realData: f,
      getHeaderRowClass: Q,
      getHeaderRowStyle: U,
      getHeaderCellClass: X,
      getHeaderCellStyle: Y,
      setCurrentRow: ee,
      toggleExpand: F,
      toggleExpandTree: b,
      rowClicked: Z,
      toggleColumn: J,
      clearTooltip: O,
      hoverColIndex: v
    };
  }
});
export {
  Ke as default
};
