import { h } from 'vue';
import type { VNode, PropType, ExtractPropTypes } from 'vue';
import type { TreeProps } from './tree.type';
import type TreeTransfer from './tree-transfer.vue';
export declare const treeTransferProps: {
    modelValue: {
        type: PropType<Array<string | number>>;
        default: () => never[];
    };
    treeProps: {
        type: PropType<TreeProps>;
        default: () => {};
    };
    titles: {
        type: PropType<[string, string]>;
        default: () => never[];
    };
    filterPlaceholder: {
        type: StringConstructor;
        default: string;
    };
    renderContent: PropType<(render: typeof h, data: unknown[], mark: string) => VNode>;
    filterable: {
        type: BooleanConstructor;
        default: boolean;
    };
};
export type TreeTransferProps = ExtractPropTypes<typeof treeTransferProps>;
export declare const treeTransferEmits: {
    'update:modelValue': (keys: Array<string | number>) => boolean;
};
export type TreeTransferEmits = typeof treeTransferEmits;
export type TreeTransferInstance = InstanceType<typeof TreeTransfer>;
