import type { PropType, ExtractPropTypes } from 'vue';
import type AvatarList from './avatar-list.vue';
export declare const avatarListProps: {
    data: {
        type: PropType<Array<Record<string, any>>>;
        default: () => never[];
    };
    indent: StringConstructor;
    size: {
        type: PropType<number | "large" | "default" | "small">;
        default: string;
    };
    fit: {
        type: StringConstructor;
        default: string;
    };
    shape: {
        type: PropType<"circle" | "square">;
        default: string;
    };
    urlField: {
        type: StringConstructor;
        default: string;
    };
    max: {
        type: NumberConstructor;
        default: number;
    };
    maxBgColor: {
        type: StringConstructor;
        default: string;
    };
    popoverProps: {
        type: PropType<Record<string, any>>;
        default: () => {};
    };
};
export type AvatarListProps = ExtractPropTypes<typeof avatarListProps>;
export declare const avatarListEmits: {
    click: (event: Record<string, any>) => boolean;
};
export type AvatarListEmits = typeof avatarListEmits;
export type AvatarListInstance = InstanceType<typeof AvatarList>;
