import type { PropType, ExtractPropTypes } from 'vue';
import type ConfirmableButton from './confirmable-button.vue';
export declare const confirmableButtonProps: {
    tip: {
        type: StringConstructor;
        default: string;
    };
    popoverProps: {
        type: PropType<Record<string, any>>;
        default: () => {};
    };
    defaultState: {
        type: PropType<Record<string, any>>;
        default: () => {
            text: boolean;
            type: string;
        };
    };
    confirmState: {
        type: PropType<Record<string, any>>;
        default: () => {
            text: boolean;
            type: string;
        };
    };
};
export type ConfirmableButtonProps = ExtractPropTypes<typeof confirmableButtonProps>;
export declare const confirmableButtonEmits: {
    confirm: () => boolean;
};
export type ConfirmableButtonEmits = typeof confirmableButtonEmits;
export type ConfirmableButtonInstance = InstanceType<typeof ConfirmableButton>;
