import type { Ref } from 'vue';
import type { ModelessDialogProps } from './modeless-dialog';
export declare const CLOSE_EVENT = "close";
export declare const OPEN_EVENT = "open";
export declare const CLOSED_EVENT = "closed";
export declare const OPENED_EVENT = "opened";
export declare const COLLAPSE_EVENT = "collapse";
export declare const MAX_EVENT = "maximize";
export declare const UPDATE_MODEL_EVENT = "update:modelValue";
export declare const useDialog: (props: ModelessDialogProps, targetRef: Ref<HTMLElement | undefined>) => {
    afterEnter: () => void;
    afterLeave: () => void;
    beforeLeave: () => void;
    handleClose: () => void;
    handleCollapse: () => void;
    collapseDialog: (collapsable?: boolean) => void;
    handleMaximize: () => void;
    maximizeDialog: () => void;
    closed: Ref<boolean, boolean>;
    shown: Ref<boolean, boolean>;
    visible: Ref<boolean, boolean>;
    collapse: Ref<boolean, boolean>;
    maximize: Ref<boolean, boolean>;
    zIndex: Ref<string | number, string | number>;
    innerClass: import("vue").ComputedRef<Record<string, boolean>>;
};
