import type { ExtractPropTypes, PropType } from 'vue';
export declare const panelProps: {
    borderless: BooleanConstructor;
    outlineless: BooleanConstructor;
    collapsed: BooleanConstructor;
    fullscreen: {
        type: PropType<boolean | Record<"left" | "right" | "top" | "bottom", string>>;
        default: boolean;
    };
    radius: StringConstructor;
    headerHeight: StringConstructor;
    padding: StringConstructor;
    bodyPadding: StringConstructor;
    footerPadding: StringConstructor;
    headerClass: StringConstructor;
    headerStyle: StringConstructor;
    bodyClass: StringConstructor;
    bodyStyle: StringConstructor;
    footerClass: StringConstructor;
    footerStyle: StringConstructor;
    fullBody: BooleanConstructor;
};
export type PanelProps = ExtractPropTypes<typeof panelProps>;
export type PanelPropKeys = keyof typeof panelProps;
export declare const panelStyleProps: readonly ["radius", "padding", "headerHeight", "bodyPadding", "footerPadding"];
export declare const panelClassProps: readonly ["borderless", "outlineless", "collapsed", "fullscreen", "fullBody"];
export declare function usePanelProps(props: PanelProps): {
    panelClass: Record<string, unknown>;
    headerClass: any;
    headerStyle: any;
    bodyClass: any;
    bodyStyle: any;
    footerClass: any;
    footerStyle: any;
    panelStyle: string[];
};
