import type { Ref } from 'vue';
import type { GetRowKey, TreeProps, LoadFunction, RowDataType } from '../simple-table';
export type TableTreeNode = {
    isLoading: boolean;
    lazy: boolean;
    level: number;
    expanded?: boolean;
};
declare function useTree({ load, treeProps, getRowKey, defaultExpandAll, expandRowKeys, }: {
    load: LoadFunction | undefined;
    treeProps: TreeProps;
    getRowKey: GetRowKey;
    defaultExpandAll: Ref<boolean>;
    expandRowKeys: Ref<string[]>;
}): {
    walkTreeNode: (data: RowDataType[], level?: number) => void;
    hasChildren: (row: Record<string, any>) => boolean;
    loadChildren: (row: RowDataType, level: number, finish?: () => void) => void;
    tableTreeMap: Ref<Record<string, TableTreeNode>, Record<string, TableTreeNode>>;
    toggleExpandTree: (row: RowDataType) => Promise<void>;
};
export { useTree };
